Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corruptsdata: Copied to github as #: 18564
Description

With graduated styled layer, the following code crashes QGIS. It works in 2.2 without any problems.

layer = iface.activelLayer()
renderer = layer.rendererV2()

f = QgsFeature()

layer.getFeatures().nextFeature(f)
s = renderer.symbolForFeature(f)

With categorized styled layer, symbolForFeature() returns None. It returns a subclass object of QgsSymbolV2 correctly in 2.2.

Crash doesn't seem to occur if the graduated styled layer has been loaded through a project file, and a subclass object of QgsSymbolV2
is returned correctly, but with categorized styled layer, it still returns None.

This method is useful for plugins which export data with styles.

Associated revisions

Revision dcc9d39a - 2014-06-01 03:06 PM - Jiirgen Fischer

fix categorized renderer crash (fixes #10096)

History

#1 - 2014-04-21 08:47 AM - Matthias Kuhn

As a workaround for the crash: embed your calls within ‘renderer.startRender()” and ‘renderer.stopRender()" to have the renderer in a state where it is able

to evaluate expressions.

In the long term it would however be nice to have somebody who knows this code to have a look at the lifetime of the expression which crashes.

#2 - 2014-04-21 05:21 PM - Minoru Akagi

Matthias Kuhn wrote:

As a workaround for the crash: embed your calls within “renderer.startRender()” and “renderer.stopRender()" to have the renderer in a state where it
is able to evaluate expressions.

Works fine with the workaround. Thanks, Matthias!

#3 - 2014-06-01 06:07 AM - Jiirgen Fischer
- Status changed from Open to Closed

Fixed in changeset commit:"dcc9d39a273eebc54f996af088daca23b31c0efb”.

#4 - 2014-07-04 12:07 AM - Alexander Bruy

- Status changed from Closed to Reopened

Still true in latest master.
Seems this method does not work as expected for almost all renderers:

- QgsSingleSymbolRendererV2 — returns feature symbol

- QgsCategorizedSymbolRendererV2 — returns None and in debug output | have message saying "there are no hashed symbols!!!"

- QgsGraduatedSymbolRendererV2 — just crashes QGIS
- QgsRuleBasedRendererV2 — returns None

Tested with point shapefile and same code as in initial post.

#5 - 2014-07-23 06:02 AM - Matthias Kuhn

- Status changed from Reopened to Feedback

| think the workaround should be accepted as solution and stated in the APl documentation according to [1]

The only thing left to fix is the crash in graduatedsymbolrenderer. The last "fix" was also just about the crash and not about changing the behavior to be

compatible with calls out of startRender() / stopRender() context.

[1] http://permalink.gmane.org/gmane.comp.gis.qgis.devel/32841

#6 - 2014-07-24 03:30 AM - Matthias Kuhn
- Resolution set to fixed/implemented
- Status changed from Feedback to Closed

No crash here.

If it's still reproducable, please reopen.

Files
symbolForFeature.zip 4.04 KB 2014-04-21 Minoru Akagi
